# osh
# Copyright (C) Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""C{ps}

Generates a stream of objects of type C{osh.process.Process}.
"""

import os
import os.path

import osh.core
import osh.process

# CLI
def _ps():
    return _Ps()

# API
def ps():
    """Generates a stream of objects of type C{osh.process.Process}.
    """
    return _Ps()

class _Ps(osh.core.Generator):

    # object interface

    def __init__(self):
        osh.core.Generator.__init__(self, '', (0, None))

    # BaseOp interface
    
    def doc(self):
        return __doc__

    def setup(self):
        pass

    # Generator interface
    
    def execute(self):
        for process in osh.process.processes():
            self.send(process)
